[ 热题 HOT 100]---448. 找到所有数组中消失的数字 ---哈希表/原地修改(秀的头皮发麻)
程序员文章站
2022-06-27 11:52:10
...
1 题目描述
给定一个范围在 1 ≤ a[i] ≤ n ( n = 数组大小 ) 的 整型数组,数组中的元素一些出现了两次,另一些只出现一次。
找到所有在 [1, n] 范围之间没有出现在数组中的数字。
您能在不使用额外空间且时间复杂度为O(n)的情况下完成这个任务吗? 你可以假定返回的数组不算在额外空间内。
示例:
输入:
[4,3,2,7,8,2,3,1]
输出:
[5,6]
来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/find-all-numbers-disappeared-in-an-array
著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。
2 解题思路
思路参考力扣官方题解官方题解,两种方法,一种是采用哈希表,另一个是原地修改
-
解决方法1:使用哈希表
使用哈希表是我看到这道题最先想到的解决方法,
就是建立一个哈希表,里面存放已经出现的数字,然后经历一次遍历,再从1到N中去寻找哈希表中不存在的数字,也就是最终结果了
算法:
(1)我们用一个哈希表 hash 来记录我们在数组中遇到的数字。我们也可以用集合 set 来记录,因为我们并不关心数字出现的次数。
(2)然后遍历给定数组的元素,插入到哈希表中,即使哈希表中已经存在某元素,再次插入了也会覆盖
(3)现在我们知道了数组中存在那些数字,只需从1⋯N 范围中找到缺失的数字。
(4)从 1⋯N 检查哈希表中是否存在,若不存在则添加到存放答案的数组中。
复杂度分析
时间复杂度:O(N)。
空间复杂度:O(N)。
-
解决方法2:原地修改
哎呦我的天,这个方法就真的很觉,我是真的真的真的想不到…原谅我脑子不够用
复杂度分析
时间复杂度:O(N)。
空间复杂度:O(1),因为我们在原地修改数组,没有使用额外的空间。
3 解决代码
-
- 解决方法1:使用哈希表《Java代码》
class Solution {
public List<Integer> findDisappearedNumbers(int[] nums) {
HashMap<Integer, Boolean> hashTable = new HashMap<Integer, Boolean>();
for(int i = 0; i < nums.length; i++){
hashTable.put(nums[i], true);
}
List<Integer> result = new LinkedList<Integer>();
for(int i = 1; i < nums.length + 1; i++){
if(!hashTable.containsKey(i)){
result.add(i);
}
}
return result;
}
}
-
- 解决方法1:使用哈希表《Java代码》
class Solution:
def findDisappearedNumbers(self, nums: List[int]) -> List[int]:
hash_table = {}
for num in nums:
hash_table[num] = 1
result = []
for num in range(1, len(nums) + 1):
if num not in hash_table:
result.append(num)
return result
- 解决方法2:原地修改《Java代码》
class Solution {
public List<Integer> findDisappearedNumbers(int[] nums) {
for(int i = 0; i < nums.length; i++){
int newIndex = Math.abs(nums[i]) - 1;
if(nums[newIndex] > 0){
nums[newIndex] *= -1;
}
}
List<Integer> result = new LinkedList<>();
for(int i = 1; i < nums.length + 1; i++){
if(nums[i - 1] > 0){
result.add(i);
}
}
return result;
}
}
- 解决方法2:原地修改《python3代码》
class Solution:
def findDisappearedNumbers(self, nums: List[int]) -> List[int]:
for i in range(0, len(nums)):
new_index = abs(nums[i]) - 1
if nums[new_index] > 0:
nums[new_index] *= -1
result = []
for i in range(1, len(nums) + 1):
if(nums[i - 1]) >0:
result.append(i)
return result